package at.ac.uibk.gitsearch.domain;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;

import javax.persistence.*;
import javax.validation.constraints.*;

import java.io.Serializable;

/**
 * A SavedSearches.
 */
@Entity
@Table(name = "saved_searches")
@Cache(usage = CacheConcurrencyStrategy.READ_WRITE)
@org.springframework.data.elasticsearch.annotations.Document(indexName = "savedsearches")
public class SavedSearches implements Serializable {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    @NotNull
    @Size(min = 1)
    @Column(name = "name", nullable = false)
    private String name;

    @NotNull
    @Column(name = "json_query", nullable = false)
    private String jsonQuery;

    @ManyToOne(optional = false)
    @JoinColumn(name = "userIdId") // sigh: just a misunderstanding: Hard to remove :-(
    @NotNull
    @JsonIgnoreProperties(value = "savedSearches", allowSetters = true)
    private User user;

    // jhipster-needle-entity-add-field - JHipster will add fields here
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public SavedSearches name(String name) {
        this.name = name;
        return this;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getJsonQuery() {
        return jsonQuery;
    }

    public SavedSearches jsonQuery(String jsonQuery) {
        this.jsonQuery = jsonQuery;
        return this;
    }

    public void setJsonQuery(String jsonQuery) {
        this.jsonQuery = jsonQuery;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }
    // jhipster-needle-entity-add-getters-setters - JHipster will add getters and setters here

    @Override
    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (!(o instanceof SavedSearches)) {
            return false;
        }
        return id != null && id.equals(((SavedSearches) o).id);
    }

    @Override
    public int hashCode() {
        return 31;
    }

    // prettier-ignore
    @Override
    public String toString() {
        return "SavedSearches{" +
            "id=" + getId() +
            ", name='" + getName() + "'" +
            ", jsonQuery='" + getJsonQuery() + "'" +
            "}";
    }
}
