package at.ac.uibk.gitsearch.web.rest;

import java.util.Optional;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.userdetails.User;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import at.ac.uibk.gitsearch.security.jwt.TokenProvider;
import at.ac.uibk.gitsearch.service.MailService;
import at.ac.uibk.gitsearch.service.UserService;

/**
 * REST controller for various tests that can be initiated by the user.
 */
@RestController
@RequestMapping("/api")
public class TestResource {

    private final Logger log = LoggerFactory.getLogger(TestResource.class);

//  @Value("${jhipster.clientApp.name}") // warning: inconsistent rename of gitSearchApp to gitSearchV2App :-(
	@SuppressWarnings("unused")
	private final static String applicationName = "gitsearchApp";

    private final MailService mailService;
    @SuppressWarnings("unused")
	private final TokenProvider tokenProvider;
    private final UserService userService;
    
    public TestResource(MailService mailService,
    		TokenProvider tokenProvider, UserService userService
    		) {
        this.mailService = mailService;
        this.tokenProvider = tokenProvider;
        this.userService = userService;
    }

    /**
     * {@code Get  /triggerInfoMail} : Triggers the info mail for the current user.
     */
    @GetMapping("/triggerInfoMail")
    public ResponseEntity<String> triggerInfoMail()  {
//       if(tokenProvider.getCurrentPrincipal().isEmpty()) {
//           log.debug("unknown user for triggerInfoMail");
//           return ResponseEntity.badRequest().build();
//       }
//       String userName = tokenProvider.getCurrentPrincipal().get().getUsername();
       
       Optional<at.ac.uibk.gitsearch.domain.User> uo = userService.getUserWithAuthorities();
       
       if(uo.isEmpty())  {
           log.debug("unknown user for triggerInfoMail");
           return ResponseEntity.badRequest().build();
       }
       boolean wasSent = mailService.sendInfoMail(uo.get());
       return ResponseEntity.ok().body(wasSent?"success":"no mail to send");
    }


}
